#ifndef MKDAT_H
#define MKDAT_H

#include "util.h"

int yyparse(void);
int yylex(void);
extern int yylineno;

extern const char *input_filename;
extern const char *output_filename;
extern int swap_endian;

void write_val(int type, int val);
void write_align(int alignment);
void write_even(void);
int get_identifier(const char *id);
void write_label(int identifier, unsigned char flags);
void write_reference(int identifier);
void write_shuffle_reference(int index);
int string_table_add(const char *str);
void write_string(int index);
int parse_char_constant(const char *str);

int get_constant(int identifier);
void define_constant(int identifier, int value);

void start_diversion(void);
void finish_diversion(void);

#define type_ulong 0
#define type_slong 1
#define type_uint 2
#define type_sint 3
#define type_ushort 4
#define type_sshort 5
#define type_uchar 6
#define type_schar 7

#endif

